"use strict";

const simpleSource = require("@promistream/simple-source");
const EndOfStream = require("@promistream/end-of-stream");

module.exports = function rangeNumbers(start, end, step = 1) {
	/* End is exclusive */
	let i = start;

	return simpleSource(() => {
		if (i >= end) {
			throw new EndOfStream();
		} else {
			let number = i;
			i += step;
			return number;
		}
	});
};
